document.addEventListener('DOMContentLoaded', function () {
 const playerCar = document.getElementById('player-car');
 const aiCars = [document.getElementById('ai-car-1'), document.getElementById('ai-car-2'), document.getElementById('ai-car-3')];
 const textDisplay = document.getElementById('text-display');
 const typingInput = document.getElementById('typing-input');
 const wpmDisplay = document.getElementById('wpm');
 const accuracyDisplay = document.getElementById('accuracy');
 const xpDisplay = document.getElementById('xp');

 let startTime;
 let correctChars = 0;
 let totalChars = 0;
 let xp = 0;
 let level = 1;

 const passages = [
  "The quick brown fox jumps over the lazy dog.",
  "Programming is fun and challenging.",
  "Practice makes perfect.",
  "Typing is an essential skill in the digital age.",
  "Keep practicing to improve your speed and accuracy."
 ];

 function startRace() {
  startTime = Date.now();
  typingInput.value = '';
  correctChars = 0;
  totalChars = 0;
  xp = 0;
  level = 1;
  updateStats();
  setRandomPassage();
  typingInput.focus();
 }

 function setRandomPassage() {
  const randomIndex = Math.floor(Math.random() * passages.length);
  textDisplay.textContent = passages[randomIndex];
 }

 function updateStats() {
  const elapsedTime = (Date.now() - startTime) / 1000;
  const wpm = Math.round((correctChars / 5) / (elapsedTime / 60));
  const accuracy = totalChars === 0 ? 100 : Math.round((correctChars / totalChars) * 100);
  wpmDisplay.textContent = `WPM: ${wpm}`;
  accuracyDisplay.textContent = `Accuracy: ${accuracy}%`;
  xpDisplay.textContent = `XP: ${xp}`;
 }

 function moveCar(car, distance) {
  car.style.left = `${distance}px`;
 }

 typingInput.addEventListener('input', function () {
  const typedText = typingInput.value;
  const passageText = textDisplay.textContent;
  totalChars = typedText.length;
  correctChars = 0;

  for (let i = 0; i < typedText.length; i++) {
   if (typedText[i] === passageText[i]) {
    correctChars++;
   }
  }

  xp += correctChars;
  updateStats();
  moveCar(playerCar, correctChars);

  if (typedText === passageText) {
   alert('You Win!');
   startRace();
  }
 });

 startRace();
});